<!---试运行列表-->
<template>
    <div class="default-main">
        <TableHeader area datePicker ref='TableHeaderRef'>

            <template #operation>
                <el-button icon='el-icon-Plus' type='primary' @click='startRunTest'>试运行</el-button>
            </template>
        </TableHeader>
        <Table ref='tableRef' />

        <!--        <el-dialog
                    v-model='timeDialog'
                    width='500px'
                    append-to-body
                    destroy-on-close>
                    <div class='block'>
                        <span class="demonstration">试运行时间</span>
                        <el-date-picker
                            :popper-append-to-body="false"
                            :v-model="dateValue"
                            format="YYYY-MM-DD HH:mm:ss"
                            value-format="YYYY-MM-DD HH:mm:ss"
                            type="datetimerange"
                            range-separator="至"
                            start-placeholder="开始日期"
                            end-placeholder="结束日期">
                        </el-date-picker>

                    </div>
                    <div class='block' style='text-align: center'>
                        <el-button type='primary' style='margin-top: 50px' @click='runTestSubmit'>确认</el-button>
                    </div>
                </el-dialog>-->
    </div>
</template>
<script setup lang='ts'>
import { ref, onMounted, provide, nextTick } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { useRouter } from 'vue-router'
import { useDictData } from '@/stores/dictData'
import { ElMessage, ElMessageBox } from 'element-plus'
import { addRunTest } from '@/api/supervision-boot/lineRunTest'
import { formatDate } from '@/utils/formatTime'

const dictData = useDictData()
const { push } = useRouter()

const TableHeaderRef = ref()
const tableRef = ref()

const tableStore = new TableStore({
    url: '/supervision-boot/tempLinedebug/pageHasDebug',
    method: 'POST',
    column: [
        { title: '', type: 'checkbox', width: 40 },
        { field: 'lineName', title: '监测点名称', minWidth: 160 },
        { field: 'connectedBus', title: '接入母线', minWidth: 160 },
        { field: 'monitoringTerminalCode', title: '终端编号', minWidth: 140 },
        { field: 'monitoringTerminalName', title: '终端名称', minWidth: 140 },
        { field: 'powerSubstationName', title: '变电站', minWidth: 160 },
        { field: 'reason', title: '调试原因', minWidth: 160 },
        {
            field: 'testRunState',
            title: '试运行状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'primary',
                2: 'success',
                3: 'danger',
                1: 'warning'
            },
            replaceValue: {
                0: '待试运行',
                1: '试运行中',
                2: '试运行成功',
                3: '试运行失败',
                null: '待试运行'
            }
        },
        { field: 'testRunTime', title: '试运行时间范围', minWidth: 260 },
        {
            field: 'status',
            title: '审核状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                1: 'primary',
                2: 'success',
                3: 'danger',
                4: 'warning'
            },
            replaceValue: {
                1: '审批中',
                2: '审批通过',
                3: '审批不通过',
                4: '已取消',
                null: '/',
                9: '/'
            }
        },
        {
            title: '操作',
            minWidth: 170,
            fixed: 'right',
            render: 'buttons',
            buttons: [
                {

                    name: 'productSetting',
                    title: '流程详情',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        handleAudit(row.processInstanceId)
                    },
                    disabled: row => {
                        return row.testRunState != 2
                    }
                }

            ]
        }
    ],

    beforeSearchFun: () => {
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
        tableStore.table.params.statveList = [2]
        // tableStore.table.params.relationUserName = tableStore.table.params.userName
    }
})


provide('tableStore', tableStore)


onMounted(() => {
    tableStore.index()
})


/** 处理审批按钮 */
const handleAudit = (instanceId: any) => {
    push({
        name: 'BpmProcessInstanceDetail',
        query: {
            id: instanceId
        }
    })
}
//试运行
let monitorIds: any = []

const startRunTest = () => {
    let flag = true
    if (tableStore.table.selection.length === 0) {
        return ElMessage({
            message: '请至少选择一个监测点进行试运行',
            type: 'warning'
        })
        return false
    }

    tableStore.table.selection.forEach(item => {
        if (item.testRunState != 0) {
            flag = false
        }
        if (item.testRunState == 0) {
            monitorIds.push(item.id)
        }
    })


    if (!flag) {
        return ElMessage({
            message: '请选择未试运行的监测点进行试运行',
            type: 'warning'
        })
        return
    }

    ElMessageBox.confirm('是否确认执行72小时监测点试运行？', '试运行', {
        confirmButtonText: '确 认',
        cancelButtonText: '取 消'
    }).then(() => {
        runTestSubmit()
    })
        .catch(() => console.info('操作取消'))

}

const runTestSubmit = () => {
    const start = new Date()
    start.setDate(start.getDate() + 1)
    start.setHours(0, 0, 0)

    const end = new Date()
    end.setDate(end.getDate() + 3)
    end.setHours(23, 59, 59)
    const startString = formatDate(start, 'YYYY-MM-DD') // 转换为 YYYY-MM-DD  格式
    const endString = formatDate(end,'YYYY-MM-DD')
    const data = {
        startTime: startString,
        endTime: endString,
        lineIds: monitorIds
    }
    addRunTest(data).then((res: any) => {
        if (res.code === 'A0000') {
            ElMessage({
                message: '发起试运行成功',
                type: 'success'
            })
            tableStore.index()
        }
    })
}


</script>

<style scoped lang='scss'>

</style>
